--    Program: 		CAPPOIMP_APPROVAL_GROUP.sql
--    Description:  Import PO APPROVAL GROUP information 
--    Revision:     1st     
--    Parameter: 	
--    Created By:   Kenny Leung
--    Date:         27-Jan-2006

set doc off;      
set verify off;
set serveroutput on size 1000000;
whenever sqlerror exit failure rollback;

declare   
   l_processed_count		number;
   l_rejected_count 		number;
   l_err_msg				varchar2(2000);
   l_err_msg_tmp			varchar2(2000);
   
   l_control_group_id		number;
                    		                 		
   cursor cur_po_control_groups_all is
      select * from CRST_PO_CONTROL_GROUPS_ALL
      for update;

begin
   l_processed_count := 0;
   l_rejected_count  := 0;
   l_err_msg := '';
   
   for cur in cur_po_control_groups_all loop   	
     l_err_msg_tmp := '';
     
     select PO_CONTROL_GROUPS_S.NEXTVAL 
     into l_control_group_id
     from DUAL;
     
     update CRST_PO_CONTROL_GROUPS_ALL
     set    control_group_id_n = l_control_group_id
     where  control_group_id = cur.CONTROL_GROUP_ID;     
     
     begin
       -- import data
       insert into PO_CONTROL_GROUPS_ALL
       (
              CONTROL_GROUP_ID        ,
              CONTROL_GROUP_NAME      ,
              LAST_UPDATE_DATE        ,
              LAST_UPDATED_BY         ,
              LAST_UPDATE_LOGIN       ,
              CREATION_DATE           ,
              CREATED_BY              ,
              REQUEST_ID              ,
              PROGRAM_APPLICATION_ID  ,
              PROGRAM_ID              ,
              PROGRAM_UPDATE_DATE     ,
              ENABLED_FLAG            ,
              DESCRIPTION             ,
              ATTRIBUTE1              ,
              ATTRIBUTE10             ,
              ATTRIBUTE11             ,
              ATTRIBUTE12             ,
              ATTRIBUTE13             ,
              ATTRIBUTE14             ,
              ATTRIBUTE15             ,
              ATTRIBUTE2              ,
              ATTRIBUTE3              ,
              ATTRIBUTE4              ,
              ATTRIBUTE5              ,
              ATTRIBUTE6              ,
              ATTRIBUTE7              ,
              ATTRIBUTE8              ,
              ATTRIBUTE9              ,
              ATTRIBUTE_CATEGORY      ,
              ORG_ID                   
       )
       values
       (
            l_control_group_id          ,
            cur.CONTROL_GROUP_NAME      ,
            cur.LAST_UPDATE_DATE        ,
            CAPBRIMP_MAPPING.GetUserMapping(cur.LAST_UPDATED_BY),
            cur.LAST_UPDATE_LOGIN       ,
            cur.CREATION_DATE           ,
            CAPBRIMP_MAPPING.GetUserMapping(cur.CREATED_BY),
            cur.REQUEST_ID              ,
            cur.PROGRAM_APPLICATION_ID  ,
            cur.PROGRAM_ID              ,
            cur.PROGRAM_UPDATE_DATE     ,
            cur.ENABLED_FLAG            ,
            cur.DESCRIPTION             ,
            cur.ATTRIBUTE1              ,
            cur.ATTRIBUTE10             ,
            cur.ATTRIBUTE11             ,
            cur.ATTRIBUTE12             ,
            cur.ATTRIBUTE13             ,
            cur.ATTRIBUTE14             ,
            cur.ATTRIBUTE15             ,
            cur.ATTRIBUTE2              ,
            cur.ATTRIBUTE3              ,
            cur.ATTRIBUTE4              ,
            cur.ATTRIBUTE5              ,
            cur.ATTRIBUTE6              ,
            cur.ATTRIBUTE7              ,
            cur.ATTRIBUTE8              ,
            cur.ATTRIBUTE9              ,
            cur.ATTRIBUTE_CATEGORY      ,
            CAPBRIMP_MAPPING.GetOrgMapping(cur.ORG_ID)                  
       );  
     exception
       when others then
     	 l_err_msg_tmp := sqlerrm;
     end;	  	    
     
     if l_err_msg_tmp IS NULL then
       l_processed_count := l_processed_count + 1;  
     else
       l_rejected_count := l_rejected_count + 1;
       l_err_msg := l_err_msg_tmp; 
     end if;
   end loop;

   if l_rejected_count = 0 then
   	 commit;
   else
     rollback;
   end if;
   
   -- insert into log table
   insert into capcnv_log ( prog_id,process_date, record_processed,record_rejected,record_extracted,err_msg) 
    values ('CAPPOIMP_APPROVAL_GROUP', sysdate, l_processed_count, l_rejected_count, l_processed_count-l_rejected_count, l_err_msg );
   
   commit;
exception 
  when others then
    dbms_output.put_line(sqlerrm);
    rollback;  
end;
/


--exit
